package fr.ocelet.model.bellecombe;

import fr.ocelet.datafacer.KmlUtils;
import fr.ocelet.model.bellecombe.Kml_BelC;
import fr.ocelet.model.bellecombe.Plant;
import fr.ocelet.model.bellecombe.ShpPl;
import fr.ocelet.runtime.Miscutils;
import fr.ocelet.runtime.geom.ocltypes.Line;
import fr.ocelet.runtime.geom.ocltypes.Point;
import fr.ocelet.runtime.model.AbstractModel;
import fr.ocelet.runtime.ocltypes.KeyMap;
import fr.ocelet.runtime.ocltypes.List;
import java.util.HashMap;
import org.eclipse.xtext.xbase.lib.InputOutput;
import org.eclipse.xtext.xbase.lib.IntegerRange;
import org.eclipse.xtext.xbase.lib.ObjectExtensions;
import org.eclipse.xtext.xbase.lib.Procedures.Procedure1;

@SuppressWarnings("all")
public class Bellecombe extends AbstractModel {
  public Bellecombe() {
    super("Bellecombe");
  }
  
  public static void main(final String[] args) {
    Bellecombe model_Bellecombe = new Bellecombe();
    model_Bellecombe.run_Bellecombe();
  }
  
  public void run_Bellecombe() {
    InputOutput.<String>println("Model Bellecombe ready to run");
    final int nbseedyr = 21;
    final double proba = 0.1;
    KeyMap<Integer, Integer> kmois = new KeyMap<Integer, Integer>();
    kmois.put(Integer.valueOf(1), Integer.valueOf(31));
    kmois.put(Integer.valueOf(2), Integer.valueOf(28));
    kmois.put(Integer.valueOf(3), Integer.valueOf(31));
    kmois.put(Integer.valueOf(4), Integer.valueOf(30));
    kmois.put(Integer.valueOf(5), Integer.valueOf(31));
    kmois.put(Integer.valueOf(6), Integer.valueOf(30));
    kmois.put(Integer.valueOf(7), Integer.valueOf(31));
    kmois.put(Integer.valueOf(8), Integer.valueOf(31));
    kmois.put(Integer.valueOf(9), Integer.valueOf(30));
    kmois.put(Integer.valueOf(10), Integer.valueOf(31));
    kmois.put(Integer.valueOf(11), Integer.valueOf(30));
    kmois.put(Integer.valueOf(12), Integer.valueOf(31));
    final ShpPl pShpPl = new ShpPl();
    final List<Plant> lPl = pShpPl.readAll();
    final List<Plant> tlPl = new List<Plant>();
    final List<Plant> olPl = new List<Plant>();
    final Kml_BelC kmlb = new Kml_BelC();
    kmlb.defStyle("st1", 1, KmlUtils.kmlColorRGBA(255, 255, 255, 255), KmlUtils.kmlColorRGBA(255, 255, 255, 255));
    kmlb.defStyle("st2", 1, KmlUtils.kmlColorRGBA(255, 255, 255, 180), KmlUtils.kmlColorRGBA(255, 255, 255, 180));
    kmlb.defStyle("st3", 1, KmlUtils.kmlColorRGBA(255, 255, 255, 100), KmlUtils.kmlColorRGBA(255, 255, 255, 100));
    kmlb.defStyle("st4", 1, KmlUtils.kmlColorRGBA(255, 255, 255, 80), KmlUtils.kmlColorRGBA(255, 255, 255, 80));
    IntegerRange _upTo = new IntegerRange(2010, 2018);
    for (final Integer yr : _upTo) {
      {
        InputOutput.<Integer>println(yr);
        IntegerRange _upTo_1 = new IntegerRange(1, 12);
        for (final Integer mo : _upTo_1) {
          {
            tlPl.clear();
            olPl.clear();
            for (final Plant pl : lPl) {
              pl.outputKml(yr, mo, kmlb);
            }
            Integer nbjm = kmois.get(mo);
            IntegerRange _upTo_2 = new IntegerRange(1, (nbjm).intValue());
            for (final Integer dy : _upTo_2) {
              for (final Plant pl_1 : lPl) {
                pl_1.ageing(Integer.valueOf(1));
              }
            }
            if ((((mo).intValue() > 5) && ((mo).intValue() < 9))) {
              for (final Plant pl_2 : lPl) {
                if ((((pl_2.getAge()).intValue() > 400) && ((pl_2.getAge()).intValue() <= 1000))) {
                  int nbseed = Double.valueOf((nbseedyr * 0.33)).intValue();
                  IntegerRange _upTo_3 = new IntegerRange(1, nbseed);
                  for (final Integer i : _upTo_3) {
                    double _random = Math.random();
                    boolean _greaterThan = (proba > _random);
                    if (_greaterThan) {
                      Point _point = new Point();
                      final Procedure1<Point> _function = (Point it) -> {
                        double _x = pl_2.getPosition().getX();
                        double _random_1 = Math.random();
                        double _minus = (_random_1 - 0.5);
                        double _multiply = (300.0 * _minus);
                        double _plus = (_x + _multiply);
                        it.setX(_plus);
                        double _y = pl_2.getPosition().getY();
                        double _random_2 = Math.random();
                        double _minus_1 = (_random_2 - 0.5);
                        double _multiply_1 = (300.0 * _minus_1);
                        double _plus_1 = (_y + _multiply_1);
                        it.setY(_plus_1);
                      };
                      Point np = ObjectExtensions.<Point>operator_doubleArrow(_point, _function);
                      Plant y = pl_2.clone(np);
                      int nbneighb = 0;
                      for (final Plant pln : lPl) {
                        {
                          double d = pln.getPosition().distance(pl_2.getPosition());
                          if ((d < 30.0)) {
                            int n = nbneighb;
                            nbneighb = (n + 1);
                          }
                        }
                      }
                      if ((nbneighb < 3)) {
                        tlPl.add(y);
                        String _plus = (yr + "-");
                        String _format = Miscutils.format(mo, "00");
                        String _plus_1 = (_plus + _format);
                        String ddeb = (_plus_1 + "-01");
                        String _plus_2 = (yr + "-");
                        String _format_1 = Miscutils.format(mo, "00");
                        String _plus_3 = (_plus_2 + _format_1);
                        String _plus_4 = (_plus_3 + "-");
                        String _format_2 = Miscutils.format(Integer.valueOf(30), "00");
                        String dfin = (_plus_4 + _format_2);
                        Integer _id = y.getId();
                        String _plus_5 = ("Seed:" + _id);
                        kmlb.addGeometry("graph", _plus_5, ddeb, dfin, Line.points(pl_2.getPosition(), y.getPosition()), "st1", 0);
                        String _plus_6 = (yr + "-");
                        String _format_3 = Miscutils.format(Integer.valueOf(((mo).intValue() + 1)), "00");
                        String _plus_7 = (_plus_6 + _format_3);
                        String _plus_8 = (_plus_7 + "-01");
                        ddeb = _plus_8;
                        String _plus_9 = (yr + "-");
                        String _format_4 = Miscutils.format(Integer.valueOf(((mo).intValue() + 1)), "00");
                        String _plus_10 = (_plus_9 + _format_4);
                        String _plus_11 = (_plus_10 + "-");
                        String _format_5 = Miscutils.format(Integer.valueOf(31), "00");
                        String _plus_12 = (_plus_11 + _format_5);
                        dfin = _plus_12;
                        Integer _id_1 = y.getId();
                        String _plus_13 = ("Seed:" + _id_1);
                        kmlb.addGeometry("graph", _plus_13, ddeb, dfin, Line.points(pl_2.getPosition(), y.getPosition()), "st2", 0);
                        String _plus_14 = (yr + "-");
                        String _format_6 = Miscutils.format(Integer.valueOf(((mo).intValue() + 2)), "00");
                        String _plus_15 = (_plus_14 + _format_6);
                        String _plus_16 = (_plus_15 + "-01");
                        ddeb = _plus_16;
                        String _plus_17 = (yr + "-");
                        String _format_7 = Miscutils.format(Integer.valueOf(((mo).intValue() + 2)), "00");
                        String _plus_18 = (_plus_17 + _format_7);
                        String _plus_19 = (_plus_18 + "-");
                        String _format_8 = Miscutils.format(Integer.valueOf(31), "00");
                        String _plus_20 = (_plus_19 + _format_8);
                        dfin = _plus_20;
                        Integer _id_2 = y.getId();
                        String _plus_21 = ("Seed:" + _id_2);
                        kmlb.addGeometry("graph", _plus_21, ddeb, dfin, Line.points(pl_2.getPosition(), y.getPosition()), "st3", 0);
                        String _plus_22 = (yr + "-");
                        String _format_9 = Miscutils.format(Integer.valueOf(((mo).intValue() + 3)), "00");
                        String _plus_23 = (_plus_22 + _format_9);
                        String _plus_24 = (_plus_23 + "-01");
                        ddeb = _plus_24;
                        String _plus_25 = (yr + "-");
                        String _format_10 = Miscutils.format(Integer.valueOf(((mo).intValue() + 3)), "00");
                        String _plus_26 = (_plus_25 + _format_10);
                        String _plus_27 = (_plus_26 + "-");
                        String _format_11 = Miscutils.format(Integer.valueOf(30), "00");
                        String _plus_28 = (_plus_27 + _format_11);
                        dfin = _plus_28;
                        Integer _id_3 = y.getId();
                        String _plus_29 = ("Seed:" + _id_3);
                        kmlb.addGeometry("graph", _plus_29, ddeb, dfin, Line.points(pl_2.getPosition(), y.getPosition()), "st4", 0);
                      }
                    }
                  }
                } else {
                  Integer _age = pl_2.getAge();
                  boolean _greaterThan_1 = ((_age).intValue() > 1600);
                  if (_greaterThan_1) {
                    olPl.add(pl_2);
                  }
                }
              }
            }
            lPl.addAll(tlPl);
            lPl.removeAll(olPl);
          }
        }
      }
    }
    InputOutput.<String>println("Saving kml file...");
    kmlb.saveAsKml();
    InputOutput.<String>println("Done.");
  }
  
  public void simulate(final HashMap<String, Object> in_params) {
    run_Bellecombe();
  }
}
