package fr.ocelet.model.bellecombe;

import fr.ocelet.datafacer.ocltypes.KmlExport;
import fr.ocelet.runtime.Miscutils;
import fr.ocelet.runtime.entity.AbstractEntity;
import fr.ocelet.runtime.entity.Hproperty;
import fr.ocelet.runtime.geom.ocltypes.Point;
import org.eclipse.xtext.xbase.lib.ObjectExtensions;
import org.eclipse.xtext.xbase.lib.Procedures.Procedure1;

@SuppressWarnings("all")
public class Plant extends AbstractEntity {
  public void setPosition(final Point position) {
    setProperty("position",position);
  }
  
  public Point getPosition() {
    return getProperty("position");
  }
  
  public void setId(final Integer id) {
    setProperty("id",id);
  }
  
  public Integer getId() {
    return getProperty("id");
  }
  
  public void setAge(final Integer age) {
    setProperty("age",age);
  }
  
  public Integer getAge() {
    return getProperty("age");
  }
  
  public void ageing(final Integer nbdays) {
    final Integer prevage = this.getAge();
    this.setAge(Integer.valueOf(((prevage).intValue() + (nbdays).intValue())));
  }
  
  public Plant clone(final Point newPos) {
    Plant _plant = new Plant();
    final Procedure1<Plant> _function = (Plant it) -> {
      it.setPosition(newPos);
      double _random = Math.random();
      double _multiply = (_random * 365.0);
      it.setAge(Integer.valueOf(Long.valueOf(Math.round(_multiply)).intValue()));
    };
    return ObjectExtensions.<Plant>operator_doubleArrow(_plant, _function);
  }
  
  public void outputKml(final Integer year, final Integer month, final KmlExport kml) {
    String deb = "";
    String fin = "";
    if (((month).intValue() < 12)) {
      String _plus = (year + "-");
      String _format = Miscutils.format(month, "00");
      String _plus_1 = (_plus + _format);
      String _plus_2 = (_plus_1 + "-01");
      deb = _plus_2;
      String _plus_3 = (year + "-");
      String _format_1 = Miscutils.format(Integer.valueOf(((month).intValue() + 1)), "00");
      String _plus_4 = (_plus_3 + _format_1);
      String _plus_5 = (_plus_4 + "-01");
      fin = _plus_5;
    } else {
      String _plus_6 = (year + "-");
      String _format_2 = Miscutils.format(month, "00");
      String _plus_7 = (_plus_6 + _format_2);
      String _plus_8 = (_plus_7 + "-01");
      deb = _plus_8;
      String _plus_9 = (Integer.valueOf(((year).intValue() + 1)) + "-01-01");
      fin = _plus_9;
    }
    double sc = 0.0;
    if ((((this.getAge()).intValue() >= 0) && ((this.getAge()).intValue() <= 400))) {
      Integer _age = this.getAge();
      double _multiply = ((_age).intValue() * 0.075);
      double _plus_10 = (20.0 + _multiply);
      sc = _plus_10;
      kml.add3DModel("Young", this.getPosition().getX(), this.getPosition().getY(), 0.0, sc, deb, fin, "Aloe_Young.dae");
    } else {
      if ((((this.getAge()).intValue() > 400) && ((this.getAge()).intValue() <= 1000))) {
        sc = 50.0;
        kml.add3DModel("Adult", this.getPosition().getX(), this.getPosition().getY(), 0.0, sc, deb, fin, "Aloe_Adult.dae");
      } else {
        if ((((this.getAge()).intValue() > 1000) && ((this.getAge()).intValue() <= 1300))) {
          Integer _age_1 = this.getAge();
          int _minus = ((_age_1).intValue() - 1000);
          double _multiply_1 = (_minus * 0.1);
          double _minus_1 = (50.0 - _multiply_1);
          sc = _minus_1;
          kml.add3DModel("Senescent", this.getPosition().getX(), this.getPosition().getY(), 0.0, sc, deb, fin, "Aloe_Senesc.dae");
        } else {
          sc = 20.0;
          kml.add3DModel("Dry", this.getPosition().getX(), this.getPosition().getY(), 0.0, sc, deb, fin, "Aloe_Old.dae");
        }
      }
    }
  }
  
  public Plant() {
    super();
    defProperty("position",new Hproperty<Point>());
    setPosition(new Point());
    defProperty("id",new Hproperty<Integer>());
    setId(new Integer("0"));
    defProperty("age",new Hproperty<Integer>());
    setAge(new Integer("0"));
  }
}
