package fr.ocelet.model.bellecombe;

import fr.ocelet.datafacer.InputDataRecord;
import fr.ocelet.datafacer.OutputDataRecord;
import fr.ocelet.datafacer.ocltypes.Shapefile;
import fr.ocelet.model.bellecombe.Plant;
import fr.ocelet.runtime.entity.Entity;
import fr.ocelet.runtime.ocltypes.List;
import java.util.HashMap;

@SuppressWarnings("all")
public class ShpPl extends Shapefile {
  public ShpPl() {
    super("data/une_plante.shp","EPSG:32740");
  }
  
  public List<Plant> readAllPlant() {
    List<Plant> _elist = new List<Plant>();
    for (InputDataRecord _record : this) {
      _elist.add(createPlantFromRecord(_record));
     }
    resetIterator();
    return _elist;
  }
  
  public List<Plant> readAll() {
    return readAllPlant();
  }
  
  public Plant createPlantFromRecord(final InputDataRecord _rec) {
                      	    Plant _entity = new Plant();
    _entity.setProperty("position",readPoint("geom"));
    _entity.setProperty("id",readInteger("FID"));
    _entity.setProperty("age",readInteger("Age"));
    return _entity;
  }
  
  public HashMap<String, String> getMatchdef() {
    HashMap<String, String> hm = new HashMap<String, String>();
    hm.put("geom","fr.ocelet.runtime.geom.ocltypes.Point");
    hm.put("FID","java.lang.Integer");
    hm.put("Age","java.lang.Integer");
    return hm;
  }
  
  public List<Plant> readFilteredPlant(final String _filt) {
    setFilter(_filt);
    return readAllPlant();
  }
  
  public OutputDataRecord createRecord(final Entity ety) throws IllegalArgumentException {
    OutputDataRecord odr = createOutputDataRec();
    if (odr != null) {
    odr.setAttribute("geom",((Plant) ety).getPosition());
    odr.setAttribute("FID",((Plant) ety).getId());
    odr.setAttribute("Age",((Plant) ety).getAge());
    }
    return odr;
  }
}
